/*
 * jkeytool - SwingInterface.java -
 * Copyright © 2009 David Roden
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

package net.pterodactylus.jkeytool.gui.swing;

import java.io.File;
import java.security.KeyStore;
import java.util.HashMap;
import java.util.Map;

import javax.swing.JFrame;

import net.pterodactylus.jkeytool.core.Core;
import net.pterodactylus.jkeytool.gui.Interface;
import net.pterodactylus.jkeytool.main.Main;

/**
 * TODO
 *
 * @author David Roden &lt;droden@gmail.com&gt;
 */
public class SwingInterface implements Interface {

	/** The core to control. */
	private Core core;

	/** The main frame. */
	private JFrame mainFrame = new JFrame("jkeytool " + Main.getVersion());

	/** Loaded key stores and their panels. */
	private final Map<KeyStore, KeyStorePanel> keyStores = new HashMap<KeyStore, KeyStorePanel>();

	//
	// INTERFACE Interface
	//

	/**
	 * Sets the core to control.
	 *
	 * @param core
	 *            The core to control
	 */
	public void setCore(Core core) {
		this.core = core;
	}

	/**
	 * {@inheritDoc}
	 */
	public void start() {
		mainFrame.setVisible(true);
		core.loadKeyStore(new File("client.p12"));
	}

	/**
	 * {@inheritDoc}
	 */
	public void stop() {
		/* TODO */
	}

	//
	// INTERFACE CoreListener
	//

	/**
	 * {@inheritDoc}
	 */
	public void keyStoreCreated(KeyStore keyStore) {
		/* TODO */
	}

	/**
	 * {@inheritDoc}
	 */
	public void keyStoreLoaded(File keyStoreFile, KeyStore keyStore) {
		KeyStorePanel keyStorePanel = new KeyStorePanel(keyStore);
		keyStores.put(keyStore, keyStorePanel);
		mainFrame.getContentPane().add(keyStorePanel);
	}

	/**
	 * {@inheritDoc}
	 */
	public void keyStoreNotCreated(String keyStoreType, Throwable reason) {
		/* TODO */
	}

	/**
	 * {@inheritDoc}
	 */
	public void keyStoreNotLoaded(File keyStoreFile) {
		/* TODO */
	}

}
